from pathlib import Path

from pydantic import BaseSettings, validator

base_dir = Path(__file__).resolve().parent.parent


class Settings(BaseSettings):
    base_dir: Path = base_dir
    server_host: str = "127.0.0.1"
    server_port: int = 8000

    database_path: str
    database_url: str = None  # will be generated by validator

    character_url: str
    planet_url: str
    planets_csv_temp_file: str
    character_csv_dir: str
    source_api_locale: str

    # generate database_url from base_dir and database_path
    @validator(
        "database_url",
    )
    def database_url_validate(cls, _, values):
        return f"sqlite:///{base_dir}/{values['database_path']}"

    class Config:
        env_file = f"{base_dir}/.env"
        env_file_encoding = "utf-8"


settings = Settings()
